/**
 * Project:  C_lesson2_ex2c  | Lesson 2, exercise 2 (c)
 * File:     main.c
 * Author:   <your name>  <date created>
 *
 * The program also shows how to convert a number (integer variable) to a string
 * of printable digits for displaying on the LCD.
 *
 * In this example, the (unsigned int) counter counts up indefinitely and the displayed
 * digits are right-justified to column 8, i.e. the LSD always stays in column 8.
 */
#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include "lib_avrbed.h"
#include <util/delay.h>

// Text strings to display
char  AppTitle[] = "Lesson 2  Ex. 2";
char  Blanks[] = "                ";     // array of 16 spaces


int  main(void)
{
    // Allocate an array of 20 char's, i.e. a string variable...
    char  strBuffer[20];    // more than enough space for 16 chars
    unsigned   iCount;      // local integer variable (unsigned!)
	int   column;

    initialise_LCD();             // Initialize I/O ports and LCD module
    lcd_command(LCD_CLR);         // Send 1-byte command to clear LCD
	lcd_command(LCD_CURSOR_OFF);  // Cursor OFF, display ON
    DDRC = DDRC & 0x07;           // Configure pins PC3..PC7 as inputs

    lcd_cursor_posn(0, 0);        // Set LCD cursor to upper LHS
    lcd_print_string(AppTitle);   // string to show on top line

    lcd_cursor_posn(1, 0);
    lcd_print_string("Counting up..");   // string to show on bottom line

    // Wait a few seconds so that we can read the text before proceeding.
    _delay_ms(2000);              // Delay function built into AVR GCC

    lcd_cursor_posn(1, 0);
    lcd_print_string(Blanks);     // Clear bottom line

	iCount = 95;     // <<<<<<<<<<<<<<<<<<<<<<  Set starting value here

    while ( TRUE )   // Loop forever
    {
        // convert number (iCount) to string of digits in strBuffer[]
        itoa(iCount, strBuffer, 10);

		// Adjust starting column according to magnitude of iCount
		// Note: This only works for positive numbers!
		column = 8;
		if (iCount >= 10)  column = 7;
		if (iCount >= 100)  column = 6;
		if (iCount >= 1000)  column = 5;
		if (iCount >= 10000)  column = 4;

        // Display buffer contents on the bottom line (row = 1)
        lcd_cursor_posn(1, column);  // Note: column is variable
        lcd_print_string(strBuffer);

        // Wait a second before next value is displayed
        _delay_ms(1000);
        lcd_cursor_posn(1, 0);
        lcd_print_string(Blanks);  // Clear bottom line

        iCount++;      // _increment_ the counter (add 1)
    }
}

