/**
 * Project:  C_lesson2  |  Lesson 2, Exercise 3a
 * File:     C_lesson2_ex3a_main.c
 * Author:   <your name>  <date created>
 *
 * This program demonstrates binary-to-hex conversion for numeric display on the LCD.
 */
#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include "lib_avrbed.h"
#include <util/delay.h>

// Text strings to display
char  AppTitle[] = "Lesson 2  Ex. 3a";
char  Blanks[] = "                ";     // array of 16 spaces


int  main(void)
{
    unsigned  ival;       // local integer variable (unsigned!)
    int   place;          // digit place, index (0 = LSD)
    int   column;
    char  hexDigit;

    initialise_LCD();             // Initialize I/O ports and LCD module
    lcd_command(LCD_CURSOR_OFF);  // Cursor OFF, display ON
    lcd_cursor_posn(0, 0);        // Set LCD cursor to upper LHS
    lcd_print_string(AppTitle);   // Show title on top line

    ival = 0;     // <<<<<<<<<<<<<<<<<<<<<<  Set integer value to display here

    place = 0;    // start with digit[0] (LSD)

    while ( place < 4 )   // process 4 hex digits
    {
        hexDigit = ival & 0x000F;    // Keep lower 4 bits, others = 0
        column = 12 - place;         // writing Right to Left
        lcd_cursor_posn(1, column);

        if (hexDigit < 10) lcd_write_char('0' + hexDigit);   // hexDigit <= 9, i.e. 0, 1, 2, .. 9
        else  lcd_write_char('A' + hexDigit - 10);           // hexDigit >= 10, i.e. A, B, C, .. F

        ival = ival >> 4;            // Shift next 4 bits into lower 4 bits
        place++;                     // next significant digit
    }
}

