/**
 * Project:  C_lesson2  |  Lesson 2, Example 4
 * File:     C_lesson2_ex4_main.c
 * Author:   <your name>  <date created>
 *
 * This program demonstrates some concepts using integer arithmetic.
 * It converts degrees Celcius to Fahrenheit.
 * It also shows usage of library functions for timing and push-button input.
 */
#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include "lib_avrbed.h"

// Text strings to display
char  MenuBar[] = "A+5 B+10 C=0 D-1";
char  Blanks[]  = "                ";     // array of 16 spaces


int  main(void)
{
    static unsigned long  start_of_50ms_interval;
    static int  last_deg_C;    // save last deg_C value here
    int   deg_C = 0;           // initialize deg_C
    int   deg_F;
    char  buff[20];

    lcd_initialise();             // Initialize I/O ports and LCD module
    lcd_command(LCD_CURSOR_OFF);  // Cursor OFF, display ON
    lcd_cursor_posn(1, 0);
    lcd_print_string(MenuBar);    // Show menu text on bottom line

    TC1_initialize();             // Initialize the timer TC1
    GLOBAL_INT_ENABLE();          // Enable interrupts

    last_deg_C = 999;
    start_of_50ms_interval = milliseconds();  // capture starting time

    while ( 1 )   // loop forever
    {
        // Every 50ms, do a button scan...
        if (milliseconds() >= (start_of_50ms_interval + 50))  // 50ms interval ended
        {
            ButtonScan(4);
            start_of_50ms_interval = milliseconds();  // start of next 50ms interval
        }

        // Check for a button hit
        if (button_hit('A'))  deg_C = deg_C + 5;
        if (button_hit('B'))  deg_C = deg_C + 10;
        if (button_hit('C'))  deg_C = 0;
        if (button_hit('D'))  deg_C = deg_C - 1;

        // If the selected temperature has changed, update the displayed data
        if (deg_C != last_deg_C)
        {
            lcd_cursor_posn(0, 0);       // clear top line
            lcd_print_string(Blanks);

            // Convert deg.C to deg.F
            deg_F = (9 * deg_C) / 5 + 32;

            itoa(deg_C, buff, 10);       // Display deg_C
            lcd_cursor_posn(0, 2);
            lcd_print_string(buff);
            lcd_write_char(0xDF);        // add degree symbol
            lcd_print_string("C = ");

            itoa(deg_F, buff, 10);       // Display deg_F
            lcd_print_string(buff);
            lcd_write_char(0xDF);        // add degree symbol
            lcd_write_char('F');

            last_deg_C = deg_C;          // save the new deg_C value
        }

    }  // end while
}

