/*
 * Program to transmit data to the host PC via the UART (USB-Serial bridge).
 * Display ASCII code table  96 printable chars only  6 lines x 16 chars.
 *
 * Hardware platform:  Atmel ATmega328P X-mini board
 * Code library required:  lib_avrXmini.a
 *
 * Test using PuTTY -- PC terminal app.
 * Configure PuTTY for Serial communications mode. Set baud rate to 57600.
 * Use Windows 'Device Manager' to find the virtual COM port number (COM#)
 * assigned to the 'mEDBG' device. (Look under 'Ports - COM & LPT').
 *
 */
#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include "lib_avrXmini.h"


int  main(void)
{
	char  c;

	UART_init(38400);
	UART_PutString("\n\n");   // Output 2 line-feeds (LF), then the heading...
	UART_PutString("ASCII Character Table \n");  // '\n' is the newline code (0x0A)
	
	for (c = ' ';  c < 127;  c++)
	{
		if ((c % 16) == 0)  UART_PutString("\n");  // print 16 chars per line
		UART_PutByte(c);
		UART_PutByte(' ');  // put a space after each char
	}

	UART_PutString("\n");   // end with a new line
}


